/*
 * atanks - obliterate each other with oversize weapons
 * Copyright (C) 2003  Thomas Hudson
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * */


#include "main.h"

class PLAYER;
class TANK;
class GLOBALDATA {
	public:
	int	WHITE, BLACK, PINK;
	double	slope[360][2];

	BOX	*updates, *lastUpdates, window;
	int	updateCount, lastUpdatesCount;
	int	stopwindow;
	int	command;

	PLAYER	**allPlayers;
	int	numPermanentPlayers;
	PLAYER	**players;
	int	numPlayers;
	int	numHumanPlayers;
	int	computerPlayersOnly;
	double	skipComputerPlay;
	int	numTanks;
	int	maxNumTanks;
	TANK	*currTank;

	int	updateMenu;

	int	curland, cursky;

	gfxDataStruct	gfxData;
	DATAFILE	*SOUND;
	char		**revengePhrases;
	char		**insults;
	char		**gloatingPhrases;

	double	cacheCirclesBG;
	double	ditherGradients;
	double	detailedLandscape;
	double	detailedSky;
	double	startmoney;
	double	turntype;
	double	rounds;
	double	interest;
	double	scoreHitUnit;
	double	scoreSelfHit;
	double	scoreUnitDestroyBonus;
	double	scoreUnitSelfDestroy;
	double	scoreRoundWinBonus;

	GLOBALDATA ();
	void	initialise ();
	int	saveToFile (FILE *file);
	int	loadFromFile (FILE *file);
	void	addPlayer (PLAYER *player);
	void	removePlayer (PLAYER *player);
	PLAYER	*getNextPlayer (int *playerCount);
	PLAYER	*createNewPlayer (ENVIRONMENT *env);
	void	destroyPlayer (PLAYER *player);
};
