/*
 * atanks - obliterate each other with oversize weapons
 * Copyright (C) 2003  Thomas Hudson
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * */


#include "physobj.h"
#include "globaldata.h"
#include "environment.h"

int PHYSICAL_OBJECT::applyPhysics ()
{
	// Normal physics

	//motion - wind affected
	if (x + xv < 1 || x + xv > (SCREEN_WIDTH-1)) {
		xv = -xv;	//bounce on the border
	} else {
		double accel = (_env->wind - xv) / mass * drag * _env->viscosity;
		xv += accel;
		x += xv;
	}
	if (y + yv >= SCREEN_HEIGHT)
	{
		yv = -yv * 0.5;
		xv *= 0.95;
		if (fabs(xv) + fabs(yv) < 0.8)
			hitSomething = 1;
	}
	y += yv;
	yv += _env->gravity * (100.0 / FRAMES_PER_SECOND);

	return (hitSomething);
}

void PHYSICAL_OBJECT::initialise ()
{
	VIRTUAL_OBJECT::initialise ();
}

/*int PHYSICAL_OBJECT::isSubClass (int classNum)
{
	if (classNum != PHYSICAL_OBJECT_CLASS)
		return (VIRTUAL_OBJECT::isSubClass (classNum));
	else
		return (TRUE);
}*/
